"use strict";
// import { List } from 'immutable';
//import { Dictionary } from 'typescript-collections';
// import { forEach } from 'typescript-collections/dist/lib/arrays';
// todo: get lodash/fp import to work
// import * as _ from 'lodash';
Object.defineProperty(exports, "__esModule", { value: true });
exports.contains = exports.append_all_toplevel_autoind = exports.append_toplevel_autoind = exports.tNode_new_k = exports.tNode_no_k = exports.append_toplevel = exports.TNode_with_children_autoind = exports.TNode = exports.TNode_with_children = void 0;
// In retrospect, this is a hilarious/ingenious way to do the type signature.
// Total throwback to my time spent as a Haskell/Functional Programming tutor.
// I don't know how users will feel about the (staggered)(access)(syntax)
// but it might just be nice ^^
// sidenote: it's not the best for memory consumption at runtime
//           since all these intermediary functions are around in some form then,
//           but I think it shouldn't slow down the program much at all
const TNode_with_children = (key) => (data) => (child_array) => {
    let res = new TNode(key, data);
    child_array.forEach((child) => res.children.set(child.id, child));
    Object.freeze(res);
    return res;
};
exports.TNode_with_children = TNode_with_children;
class TNode {
    constructor(key, data) {
        //kind: "non_leaf" | "leaf" = "non_leaf";
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "data", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "size", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 1n
        });
        Object.defineProperty(this, "children", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Map()
        });
        Object.defineProperty(this, "max_depth", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        this.id = key;
        this.data = data;
    }
}
exports.TNode = TNode;
/**
 *
 * Constructor for a AutoIndTree<D> node
 *
 * @param data
 * @param child_array
 * @returns
 */
const TNode_with_children_autoind = (data) => (child_array) => {
    let res = new TNode(0n, data);
    child_array.forEach((child_node, ind) => res.children.set(BigInt(ind), tNode_new_k(BigInt(ind), child_node)));
    return res;
};
exports.TNode_with_children_autoind = TNode_with_children_autoind;
const append_toplevel = (tree) => (node) => {
    let new_child = tree.children;
    new_child.set(node.id, node);
    return {
        ...tree,
        children: new_child,
        max_depth: tree.max_depth == 0 ? 1 : tree.max_depth,
        size: tree.size + 1n,
        // todo: update all metadata
        // like max_depth = max previous n.max_depth+1
    };
};
exports.append_toplevel = append_toplevel;
function tNode_no_k(d) {
    return new TNode(0n, d);
}
exports.tNode_no_k = tNode_no_k;
function tNode_new_k(k, n) {
    return { ...n, k: k };
}
exports.tNode_new_k = tNode_new_k;
/**
 *
 * @param tree that shall get new child
 * @param node to append - key gets scrubbed and auto assigned
 * @returns
 */
const append_toplevel_autoind = (tree) => (n) => {
    let new_child_hm = tree.children;
    let new_ind = BigInt(tree.children.size);
    new_child_hm.set(new_ind, { ...n, id: new_ind }); // TODO: test
    return {
        ...tree,
        children: new_child_hm,
        // todo: update all metadata
        // (copy from above when ready)
    };
};
exports.append_toplevel_autoind = append_toplevel_autoind;
/**
 * TODO: fix that this function mutates t!
 * @param t
 * @returns
 */
const append_all_toplevel_autoind = (t) => (ns) => {
    let first_new_ind = BigInt(t.children.size);
    ns.forEach((appendee, arr_i) => {
        let new_child = tNode_new_k(first_new_ind + BigInt(arr_i), appendee);
        t.children.set(new_child.id, new_child);
    });
    return t;
};
exports.append_all_toplevel_autoind = append_all_toplevel_autoind;
const contains = (t) => (p) => {
    // todo
    return false;
};
exports.contains = contains;
// EXAMPLE / TEST OBJECTS
const test_tree_1_3 = (0, exports.TNode_with_children)(0n)("root of 1-3 tree")([new TNode(0n, "child node #1"),
    new TNode(1n, "the label appearing in a path"),
    new TNode(2n, "or a whole task in Todoist"),
]);
const test_tree_1_4 = (0, exports.append_toplevel_autoind)(test_tree_1_3)(new TNode(2n, "2nd root?"));
